#require 'googleoauth/hash_response'

module GoogleOAuth
  class Client
      
    @@token = nil
     
    def initialize(options = {})
        @client_id = options[:client_id]
        @client_secret = options[:client_secret]
        @redirect = options[:redirect]
    end
  
    def authorize_url(options = {})
      consumer.auth_code.authorize_url(
          :response_type => 'code',
          :client_id => @client_id,
          :redirect_uri => @redirect,
          :scope => options[:scope]
      )
    end
    
    def authorize(options = {})
        @@token = consumer.auth_code.get_token(
            options[:code],
            :redirect_uri => @redirect
        )
    end
       
    def request(request_uri)
        @@token.get("https://www.googleapis.com/#{request_uri}".gsub('\/\/', '')).body
    end
    
    private
      def consumer
          OAuth2::Client.new(
              @client_id,
              @client_secret,
              :site => 'https://accounts.google.com',
              :authorize_url => '/o/oauth2/auth',
              :token_url => '/o/oauth2/token'
         )
      end
  end
end